(function(){"use strict";try{var e=document.createElement("style");e.appendChild(document.createTextNode(".mk-input{min-height:1.4em}.mk-input span{outline:none;white-space:pre-wrap}.mk-suggestions{border:1px solid #ccc;max-height:186px;overflow-y:auto;padding-left:0;position:absolute;background:white;width:fit-content;min-width:100px;transition:1.1s ease-out;filter:blur(0);transform:scale(1);opacity:1;visibility:visible;color:#000;border-radius:4%;box-shadow:0 3px 6px -2px #0009}.mk-suggestions li{padding:.5rem}.mk-suggestions li:hover,.mk-suggestion-active{background-color:#cce9ff;color:#2589f5;cursor:pointer}")),document.head.appendChild(e)}catch(i){console.error("vite-plugin-css-injected-by-js",i)}})();
var Tt = (a, t, r) => {
  if (!t.has(a))
    throw TypeError("Cannot " + r);
};
var $ = (a, t, r) => (Tt(a, t, "read from private field"), r ? r.call(a) : t.get(a)), He = (a, t, r) => {
  if (t.has(a))
    throw TypeError("Cannot add the same private member more than once");
  t instanceof WeakSet ? t.add(a) : t.set(a, r);
};
import be, { useContext as kt, Children as St, isValidElement as ze, useMemo as ee, useRef as ie, useLayoutEffect as jt, forwardRef as At, useEffect as Re, useState as Ce, createElement as Dt, useCallback as Je } from "react";
const G = {
  UP: "ArrowUp",
  DOWN: "ArrowDown",
  LEFT: "ArrowLeft",
  RIGHT: "ArrowRight",
  END: "End",
  HOME: "Home",
  PAGE_DOWN: "PageDown",
  PAGE_UP: "PageUp",
  ENTER: "Enter",
  TAB: "Tab",
  SPACE: " ",
  BACKSPACE: "Backspace",
  DELETE: "Delete",
  COMMA: ",",
  ESC: "Escape"
};
var W = /* @__PURE__ */ ((a) => (a.LABEL = "__label__", a.VALUE = "__value__", a))(W || {});
const Xe = "mk-input", Ze = {
  trigger: "@",
  markup: "@[__label__](__value__)",
  data: []
};
class Nt {
  constructor(t, r) {
    this.raw = t, this.uniRegExp = r, this.done = !1;
  }
  [Symbol.iterator]() {
    return this;
  }
  next() {
    if (this.done)
      return { done: this.done, value: null };
    let t = this.uniRegExp.exec(this.raw);
    if (t === null)
      return this.done = !0, { done: !1, value: [this.raw, null] };
    let [r, n, i] = this.extractPieces(t);
    return this.raw = i, { done: !1, value: [r, n] };
  }
  extractPieces(t) {
    const r = this.extractMark(t), n = r.input.substring(0, r.index), i = r.input.substring(r.index + r.annotation.length);
    return [n, r, i];
  }
  extractMark(t) {
    let r = t[0], n = 0, i = t[1], s = t[2];
    for (; !(i || s); )
      n++, i = t[2 * n + 1], s = t[2 * n + 2];
    let l = t.index, c = t.input;
    return { annotation: r, label: i, value: s, input: c, index: l, childIndex: n };
  }
}
class se {
  get regExps() {
    return this.markups.map(It);
  }
  static split(t, r) {
    const n = r.map((i) => i.markup);
    return () => new se(n).split(t);
  }
  constructor(t) {
    this.markups = t, this.uniRegExp = new RegExp(this.regExps.map((r) => r.source).join("|"));
  }
  split(t) {
    return this.iterateMatches(t);
  }
  iterateMatches(t) {
    const r = [];
    for (let [n, i] of new Nt(t, this.uniRegExp))
      r.push(n), i !== null && r.push(Mt(i, this.markups[i.childIndex]));
    return r;
  }
}
const we = Object.assign, It = (a) => {
  const t = Q(a), r = a[a.indexOf(W.LABEL) + W.LABEL.length], n = a[a.indexOf(W.VALUE) + W.VALUE.length];
  return new RegExp(
    t.replace(W.LABEL, `([^${Q(r || "")}]+?)`).replace(W.VALUE, `([^${Q(n || "")}]+?)`)
  );
}, Lt = (a) => {
  const r = Q(a) + "(\\w*)";
  return new RegExp(r);
};
function me(a, t, r) {
  let n = a.replace(W.LABEL, t);
  return r ? n.replace(W.VALUE, r) : n;
}
function pr(a, t, ...r) {
  return r.length ? new se(r).split(a).reduce((i, s) => i += ue(s) ? t(s) : s, "") : a;
}
const Q = (a) => a.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&");
function Qe(a, t) {
  let r = "";
  for (let n of a)
    r += ue(n) ? me(t[n.childIndex].markup, n.label, n.value) : n;
  return r;
}
const Mt = (a, t) => a.annotation !== me(t, a.label, a.value) ? { ...a, label: a.value, value: a.label } : a, oe = (a, t = 0) => {
  let r = 3735928559 ^ t, n = 1103547991 ^ t;
  for (let i = 0, s; i < a.length; i++)
    s = a.charCodeAt(i), r = Math.imul(r ^ s, 2654435761), n = Math.imul(n ^ s, 1597334677);
  return r = Math.imul(r ^ r >>> 16, 2246822507) ^ Math.imul(n ^ n >>> 13, 3266489909), n = Math.imul(n ^ n >>> 16, 2246822507) ^ Math.imul(r ^ r >>> 13, 3266489909), 4294967296 * (2097151 & n) + (r >>> 0);
}, ue = (a) => typeof a == "object", Bt = (a) => typeof a == "function", Vt = (a) => a.startsWith("on"), Wt = (a) => ze(a) ? !0 : ze(a == null ? void 0 : a[0]);
function $t(a) {
  if (Wt(a))
    return St.map(a, (r) => t(r.props));
  if (a != null && a.length)
    return a.map(t);
  return [Ze];
  function t(r) {
    return we({}, Ze, r);
  }
}
const Ut = (a) => {
  const t = be.createContext(void 0);
  t.displayName = a;
  const r = i(t), n = t.Provider;
  return [r, n];
  function i(s) {
    return () => {
      const l = kt(s);
      if (l)
        return l;
      throw new Error(`The context ${s.displayName} didn't found!`);
    };
  }
}, [ce, Yt] = Ut("MarkedInputStoreProvider"), Ft = () => ee(() => new z(), []);
class z {
  constructor(t = NaN) {
    this._position = t;
  }
  get isBlurred() {
    return Number.isNaN(this._position);
  }
  clear() {
    this._position = NaN;
  }
  static setIndex(t, r) {
    const n = window.getSelection();
    if (!(n != null && n.anchorNode) || !n.rangeCount)
      return;
    const i = n.getRangeAt(0);
    i == null || i.setStart(t.firstChild || t, r), i == null || i.setEnd(t.firstChild || t, r);
  }
  static getCaretIndex(t) {
    let r = 0;
    const n = window.getSelection();
    if (!(n != null && n.rangeCount))
      return r;
    const i = n.getRangeAt(0), s = i.cloneRange();
    return s.selectNodeContents(t), s.setEnd(i.endContainer, i.endOffset), r = s.toString().length, r;
  }
  getPosition() {
    let t = this._position;
    return this._position = NaN, t;
  }
  setPosition(t) {
    this._position = t;
  }
  static setCaretToEnd(t) {
    const r = window.getSelection();
    r == null || r.setPosition(t, 1);
  }
  static getIndex() {
    var r;
    const t = window.getSelection();
    return (r = t == null ? void 0 : t.anchorOffset) != null ? r : NaN;
  }
  saveRightOffset() {
    var n, i;
    const t = window.getSelection(), r = (i = (n = t == null ? void 0 : t.anchorNode) == null ? void 0 : n.textContent) == null ? void 0 : i.length;
    this._position = r != null ? r : NaN;
  }
  restoreRightOffset() {
    var s, l;
    if (this.isBlurred)
      return;
    const t = window.getSelection(), r = t != null && t.rangeCount ? t.getRangeAt(0) : null;
    if (!(t != null && t.anchorNode))
      return;
    let n = (t == null ? void 0 : t.anchorNode.firstChild) || (t == null ? void 0 : t.anchorNode), i = ((l = (s = n == null ? void 0 : n.textContent) == null ? void 0 : s.length) != null ? l : 0) - this._position;
    r == null || r.setStart(n, i), r == null || r.setEnd(n, i), this.clear();
  }
  static setIndex1(t) {
    const r = window.getSelection();
    if (!(r != null && r.anchorNode) || !r.rangeCount)
      return;
    const n = r.getRangeAt(0);
    n == null || n.setStart(n.startContainer.firstChild || n.startContainer, t), n == null || n.setEnd(n.startContainer.firstChild || n.startContainer, t);
  }
  setCaretRightTo(t, r) {
    const n = window.getSelection(), i = n == null ? void 0 : n.getRangeAt(0);
    i == null || i.setStart(i.endContainer, r), i == null || i.setEnd(i.endContainer, r);
  }
}
const Kt = (a) => {
  const t = ie(NaN);
  function r() {
    !a.current || (t.current = z.getCaretIndex(a.current));
  }
  function n() {
    !a.current || (z.setIndex(a.current, t.current), t.current = NaN);
  }
  return jt(() => {
    Number.isNaN(t.current) || n();
  }), r;
};
var Y = /* @__PURE__ */ ((a) => (a[a.Change = 0] = "Change", a[a.Delete = 1] = "Delete", a))(Y || {}), ye = { exports: {} }, H = {};
/*
object-assign
(c) Sindre Sorhus
@license MIT
*/
var _e, et;
function nt() {
  if (et)
    return _e;
  et = 1;
  var a = Object.getOwnPropertySymbols, t = Object.prototype.hasOwnProperty, r = Object.prototype.propertyIsEnumerable;
  function n(s) {
    if (s == null)
      throw new TypeError("Object.assign cannot be called with null or undefined");
    return Object(s);
  }
  function i() {
    try {
      if (!Object.assign)
        return !1;
      var s = new String("abc");
      if (s[5] = "de", Object.getOwnPropertyNames(s)[0] === "5")
        return !1;
      for (var l = {}, c = 0; c < 10; c++)
        l["_" + String.fromCharCode(c)] = c;
      var p = Object.getOwnPropertyNames(l).map(function(f) {
        return l[f];
      });
      if (p.join("") !== "0123456789")
        return !1;
      var g = {};
      return "abcdefghijklmnopqrst".split("").forEach(function(f) {
        g[f] = f;
      }), Object.keys(Object.assign({}, g)).join("") === "abcdefghijklmnopqrst";
    } catch {
      return !1;
    }
  }
  return _e = i() ? Object.assign : function(s, l) {
    for (var c, p = n(s), g, f = 1; f < arguments.length; f++) {
      c = Object(arguments[f]);
      for (var C in c)
        t.call(c, C) && (p[C] = c[C]);
      if (a) {
        g = a(c);
        for (var x = 0; x < g.length; x++)
          r.call(c, g[x]) && (p[g[x]] = c[g[x]]);
      }
    }
    return p;
  }, _e;
}
/** @license React v17.0.2
 * react-jsx-runtime.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var tt;
function qt() {
  if (tt)
    return H;
  tt = 1, nt();
  var a = be, t = 60103;
  if (H.Fragment = 60107, typeof Symbol == "function" && Symbol.for) {
    var r = Symbol.for;
    t = r("react.element"), H.Fragment = r("react.fragment");
  }
  var n = a.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner, i = Object.prototype.hasOwnProperty, s = { key: !0, ref: !0, __self: !0, __source: !0 };
  function l(c, p, g) {
    var f, C = {}, x = null, h = null;
    g !== void 0 && (x = "" + g), p.key !== void 0 && (x = "" + p.key), p.ref !== void 0 && (h = p.ref);
    for (f in p)
      i.call(p, f) && !s.hasOwnProperty(f) && (C[f] = p[f]);
    if (c && c.defaultProps)
      for (f in p = c.defaultProps, p)
        C[f] === void 0 && (C[f] = p[f]);
    return { $$typeof: t, type: c, key: x, ref: h, props: C, _owner: n.current };
  }
  return H.jsx = l, H.jsxs = l, H;
}
var xe = {};
/** @license React v17.0.2
 * react-jsx-runtime.development.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var rt;
function Gt() {
  return rt || (rt = 1, function(a) {
    process.env.NODE_ENV !== "production" && function() {
      var t = be, r = nt(), n = 60103, i = 60106;
      a.Fragment = 60107;
      var s = 60108, l = 60114, c = 60109, p = 60110, g = 60112, f = 60113, C = 60120, x = 60115, h = 60116, w = 60121, A = 60122, O = 60117, k = 60129, P = 60131;
      if (typeof Symbol == "function" && Symbol.for) {
        var E = Symbol.for;
        n = E("react.element"), i = E("react.portal"), a.Fragment = E("react.fragment"), s = E("react.strict_mode"), l = E("react.profiler"), c = E("react.provider"), p = E("react.context"), g = E("react.forward_ref"), f = E("react.suspense"), C = E("react.suspense_list"), x = E("react.memo"), h = E("react.lazy"), w = E("react.block"), A = E("react.server.block"), O = E("react.fundamental"), E("react.scope"), E("react.opaque.id"), k = E("react.debug_trace_mode"), E("react.offscreen"), P = E("react.legacy_hidden");
      }
      var S = typeof Symbol == "function" && Symbol.iterator, N = "@@iterator";
      function F(e) {
        if (e === null || typeof e != "object")
          return null;
        var o = S && e[S] || e[N];
        return typeof o == "function" ? o : null;
      }
      var M = t.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED;
      function T(e) {
        {
          for (var o = arguments.length, u = new Array(o > 1 ? o - 1 : 0), d = 1; d < o; d++)
            u[d - 1] = arguments[d];
          D("error", e, u);
        }
      }
      function D(e, o, u) {
        {
          var d = M.ReactDebugCurrentFrame, R = d.getStackAddendum();
          R !== "" && (o += "%s", u = u.concat([R]));
          var b = u.map(function(_) {
            return "" + _;
          });
          b.unshift("Warning: " + o), Function.prototype.apply.call(console[e], console, b);
        }
      }
      var J = !1;
      function ot(e) {
        return !!(typeof e == "string" || typeof e == "function" || e === a.Fragment || e === l || e === k || e === s || e === f || e === C || e === P || J || typeof e == "object" && e !== null && (e.$$typeof === h || e.$$typeof === x || e.$$typeof === c || e.$$typeof === p || e.$$typeof === g || e.$$typeof === O || e.$$typeof === w || e[0] === A));
      }
      function it(e, o, u) {
        var d = o.displayName || o.name || "";
        return e.displayName || (d !== "" ? u + "(" + d + ")" : u);
      }
      function Oe(e) {
        return e.displayName || "Context";
      }
      function I(e) {
        if (e == null)
          return null;
        if (typeof e.tag == "number" && T("Received an unexpected object in getComponentName(). This is likely a bug in React. Please file an issue."), typeof e == "function")
          return e.displayName || e.name || null;
        if (typeof e == "string")
          return e;
        switch (e) {
          case a.Fragment:
            return "Fragment";
          case i:
            return "Portal";
          case l:
            return "Profiler";
          case s:
            return "StrictMode";
          case f:
            return "Suspense";
          case C:
            return "SuspenseList";
        }
        if (typeof e == "object")
          switch (e.$$typeof) {
            case p:
              var o = e;
              return Oe(o) + ".Consumer";
            case c:
              var u = e;
              return Oe(u._context) + ".Provider";
            case g:
              return it(e, e.render, "ForwardRef");
            case x:
              return I(e.type);
            case w:
              return I(e._render);
            case h: {
              var d = e, R = d._payload, b = d._init;
              try {
                return I(b(R));
              } catch {
                return null;
              }
            }
          }
        return null;
      }
      var X = 0, Pe, Te, ke, Se, je, Ae, De;
      function Ne() {
      }
      Ne.__reactDisabledLog = !0;
      function st() {
        {
          if (X === 0) {
            Pe = console.log, Te = console.info, ke = console.warn, Se = console.error, je = console.group, Ae = console.groupCollapsed, De = console.groupEnd;
            var e = {
              configurable: !0,
              enumerable: !0,
              value: Ne,
              writable: !0
            };
            Object.defineProperties(console, {
              info: e,
              log: e,
              warn: e,
              error: e,
              group: e,
              groupCollapsed: e,
              groupEnd: e
            });
          }
          X++;
        }
      }
      function ut() {
        {
          if (X--, X === 0) {
            var e = {
              configurable: !0,
              enumerable: !0,
              writable: !0
            };
            Object.defineProperties(console, {
              log: r({}, e, {
                value: Pe
              }),
              info: r({}, e, {
                value: Te
              }),
              warn: r({}, e, {
                value: ke
              }),
              error: r({}, e, {
                value: Se
              }),
              group: r({}, e, {
                value: je
              }),
              groupCollapsed: r({}, e, {
                value: Ae
              }),
              groupEnd: r({}, e, {
                value: De
              })
            });
          }
          X < 0 && T("disabledDepth fell below zero. This is a bug in React. Please file an issue.");
        }
      }
      var le = M.ReactCurrentDispatcher, fe;
      function te(e, o, u) {
        {
          if (fe === void 0)
            try {
              throw Error();
            } catch (R) {
              var d = R.stack.trim().match(/\n( *(at )?)/);
              fe = d && d[1] || "";
            }
          return `
` + fe + e;
        }
      }
      var de = !1, re;
      {
        var ct = typeof WeakMap == "function" ? WeakMap : Map;
        re = new ct();
      }
      function Ie(e, o) {
        if (!e || de)
          return "";
        {
          var u = re.get(e);
          if (u !== void 0)
            return u;
        }
        var d;
        de = !0;
        var R = Error.prepareStackTrace;
        Error.prepareStackTrace = void 0;
        var b;
        b = le.current, le.current = null, st();
        try {
          if (o) {
            var _ = function() {
              throw Error();
            };
            if (Object.defineProperty(_.prototype, "props", {
              set: function() {
                throw Error();
              }
            }), typeof Reflect == "object" && Reflect.construct) {
              try {
                Reflect.construct(_, []);
              } catch (V) {
                d = V;
              }
              Reflect.construct(e, [], _);
            } else {
              try {
                _.call();
              } catch (V) {
                d = V;
              }
              e.call(_.prototype);
            }
          } else {
            try {
              throw Error();
            } catch (V) {
              d = V;
            }
            e();
          }
        } catch (V) {
          if (V && d && typeof V.stack == "string") {
            for (var v = V.stack.split(`
`), j = d.stack.split(`
`), m = v.length - 1, y = j.length - 1; m >= 1 && y >= 0 && v[m] !== j[y]; )
              y--;
            for (; m >= 1 && y >= 0; m--, y--)
              if (v[m] !== j[y]) {
                if (m !== 1 || y !== 1)
                  do
                    if (m--, y--, y < 0 || v[m] !== j[y]) {
                      var B = `
` + v[m].replace(" at new ", " at ");
                      return typeof e == "function" && re.set(e, B), B;
                    }
                  while (m >= 1 && y >= 0);
                break;
              }
          }
        } finally {
          de = !1, le.current = b, ut(), Error.prepareStackTrace = R;
        }
        var q = e ? e.displayName || e.name : "", Ge = q ? te(q) : "";
        return typeof e == "function" && re.set(e, Ge), Ge;
      }
      function Le(e, o, u) {
        return Ie(e, !1);
      }
      function lt(e) {
        var o = e.prototype;
        return !!(o && o.isReactComponent);
      }
      function ne(e, o, u) {
        if (e == null)
          return "";
        if (typeof e == "function")
          return Ie(e, lt(e));
        if (typeof e == "string")
          return te(e);
        switch (e) {
          case f:
            return te("Suspense");
          case C:
            return te("SuspenseList");
        }
        if (typeof e == "object")
          switch (e.$$typeof) {
            case g:
              return Le(e.render);
            case x:
              return ne(e.type, o, u);
            case w:
              return Le(e._render);
            case h: {
              var d = e, R = d._payload, b = d._init;
              try {
                return ne(b(R), o, u);
              } catch {
              }
            }
          }
        return "";
      }
      var Me = {}, Be = M.ReactDebugCurrentFrame;
      function ae(e) {
        if (e) {
          var o = e._owner, u = ne(e.type, e._source, o ? o.type : null);
          Be.setExtraStackFrame(u);
        } else
          Be.setExtraStackFrame(null);
      }
      function ft(e, o, u, d, R) {
        {
          var b = Function.call.bind(Object.prototype.hasOwnProperty);
          for (var _ in e)
            if (b(e, _)) {
              var v = void 0;
              try {
                if (typeof e[_] != "function") {
                  var j = Error((d || "React class") + ": " + u + " type `" + _ + "` is invalid; it must be a function, usually from the `prop-types` package, but received `" + typeof e[_] + "`.This often happens because of typos such as `PropTypes.function` instead of `PropTypes.func`.");
                  throw j.name = "Invariant Violation", j;
                }
                v = e[_](o, _, d, u, null, "SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED");
              } catch (m) {
                v = m;
              }
              v && !(v instanceof Error) && (ae(R), T("%s: type specification of %s `%s` is invalid; the type checker function must return `null` or an `Error` but returned a %s. You may have forgotten to pass an argument to the type checker creator (arrayOf, instanceOf, objectOf, oneOf, oneOfType, and shape all require an argument).", d || "React class", u, _, typeof v), ae(null)), v instanceof Error && !(v.message in Me) && (Me[v.message] = !0, ae(R), T("Failed %s type: %s", u, v.message), ae(null));
            }
        }
      }
      var Z = M.ReactCurrentOwner, pe = Object.prototype.hasOwnProperty, dt = {
        key: !0,
        ref: !0,
        __self: !0,
        __source: !0
      }, Ve, We, ge;
      ge = {};
      function pt(e) {
        if (pe.call(e, "ref")) {
          var o = Object.getOwnPropertyDescriptor(e, "ref").get;
          if (o && o.isReactWarning)
            return !1;
        }
        return e.ref !== void 0;
      }
      function gt(e) {
        if (pe.call(e, "key")) {
          var o = Object.getOwnPropertyDescriptor(e, "key").get;
          if (o && o.isReactWarning)
            return !1;
        }
        return e.key !== void 0;
      }
      function vt(e, o) {
        if (typeof e.ref == "string" && Z.current && o && Z.current.stateNode !== o) {
          var u = I(Z.current.type);
          ge[u] || (T('Component "%s" contains the string ref "%s". Support for string refs will be removed in a future major release. This case cannot be automatically converted to an arrow function. We ask you to manually fix this case by using useRef() or createRef() instead. Learn more about using refs safely here: https://reactjs.org/link/strict-mode-string-ref', I(Z.current.type), e.ref), ge[u] = !0);
        }
      }
      function ht(e, o) {
        {
          var u = function() {
            Ve || (Ve = !0, T("%s: `key` is not a prop. Trying to access it will result in `undefined` being returned. If you need to access the same value within the child component, you should pass it as a different prop. (https://reactjs.org/link/special-props)", o));
          };
          u.isReactWarning = !0, Object.defineProperty(e, "key", {
            get: u,
            configurable: !0
          });
        }
      }
      function Et(e, o) {
        {
          var u = function() {
            We || (We = !0, T("%s: `ref` is not a prop. Trying to access it will result in `undefined` being returned. If you need to access the same value within the child component, you should pass it as a different prop. (https://reactjs.org/link/special-props)", o));
          };
          u.isReactWarning = !0, Object.defineProperty(e, "ref", {
            get: u,
            configurable: !0
          });
        }
      }
      var _t = function(e, o, u, d, R, b, _) {
        var v = {
          $$typeof: n,
          type: e,
          key: o,
          ref: u,
          props: _,
          _owner: b
        };
        return v._store = {}, Object.defineProperty(v._store, "validated", {
          configurable: !1,
          enumerable: !1,
          writable: !0,
          value: !1
        }), Object.defineProperty(v, "_self", {
          configurable: !1,
          enumerable: !1,
          writable: !1,
          value: d
        }), Object.defineProperty(v, "_source", {
          configurable: !1,
          enumerable: !1,
          writable: !1,
          value: R
        }), Object.freeze && (Object.freeze(v.props), Object.freeze(v)), v;
      };
      function xt(e, o, u, d, R) {
        {
          var b, _ = {}, v = null, j = null;
          u !== void 0 && (v = "" + u), gt(o) && (v = "" + o.key), pt(o) && (j = o.ref, vt(o, R));
          for (b in o)
            pe.call(o, b) && !dt.hasOwnProperty(b) && (_[b] = o[b]);
          if (e && e.defaultProps) {
            var m = e.defaultProps;
            for (b in m)
              _[b] === void 0 && (_[b] = m[b]);
          }
          if (v || j) {
            var y = typeof e == "function" ? e.displayName || e.name || "Unknown" : e;
            v && ht(_, y), j && Et(_, y);
          }
          return _t(e, v, j, R, d, Z.current, _);
        }
      }
      var ve = M.ReactCurrentOwner, $e = M.ReactDebugCurrentFrame;
      function K(e) {
        if (e) {
          var o = e._owner, u = ne(e.type, e._source, o ? o.type : null);
          $e.setExtraStackFrame(u);
        } else
          $e.setExtraStackFrame(null);
      }
      var he;
      he = !1;
      function Ee(e) {
        return typeof e == "object" && e !== null && e.$$typeof === n;
      }
      function Ue() {
        {
          if (ve.current) {
            var e = I(ve.current.type);
            if (e)
              return `

Check the render method of \`` + e + "`.";
          }
          return "";
        }
      }
      function Rt(e) {
        {
          if (e !== void 0) {
            var o = e.fileName.replace(/^.*[\\\/]/, ""), u = e.lineNumber;
            return `

Check your code at ` + o + ":" + u + ".";
          }
          return "";
        }
      }
      var Ye = {};
      function bt(e) {
        {
          var o = Ue();
          if (!o) {
            var u = typeof e == "string" ? e : e.displayName || e.name;
            u && (o = `

Check the top-level render call using <` + u + ">.");
          }
          return o;
        }
      }
      function Fe(e, o) {
        {
          if (!e._store || e._store.validated || e.key != null)
            return;
          e._store.validated = !0;
          var u = bt(o);
          if (Ye[u])
            return;
          Ye[u] = !0;
          var d = "";
          e && e._owner && e._owner !== ve.current && (d = " It was passed a child from " + I(e._owner.type) + "."), K(e), T('Each child in a list should have a unique "key" prop.%s%s See https://reactjs.org/link/warning-keys for more information.', u, d), K(null);
        }
      }
      function Ke(e, o) {
        {
          if (typeof e != "object")
            return;
          if (Array.isArray(e))
            for (var u = 0; u < e.length; u++) {
              var d = e[u];
              Ee(d) && Fe(d, o);
            }
          else if (Ee(e))
            e._store && (e._store.validated = !0);
          else if (e) {
            var R = F(e);
            if (typeof R == "function" && R !== e.entries)
              for (var b = R.call(e), _; !(_ = b.next()).done; )
                Ee(_.value) && Fe(_.value, o);
          }
        }
      }
      function Ct(e) {
        {
          var o = e.type;
          if (o == null || typeof o == "string")
            return;
          var u;
          if (typeof o == "function")
            u = o.propTypes;
          else if (typeof o == "object" && (o.$$typeof === g || o.$$typeof === x))
            u = o.propTypes;
          else
            return;
          if (u) {
            var d = I(o);
            ft(u, e.props, "prop", d, e);
          } else if (o.PropTypes !== void 0 && !he) {
            he = !0;
            var R = I(o);
            T("Component %s declared `PropTypes` instead of `propTypes`. Did you misspell the property assignment?", R || "Unknown");
          }
          typeof o.getDefaultProps == "function" && !o.getDefaultProps.isReactClassApproved && T("getDefaultProps is only used on classic React.createClass definitions. Use a static property named `defaultProps` instead.");
        }
      }
      function wt(e) {
        {
          for (var o = Object.keys(e.props), u = 0; u < o.length; u++) {
            var d = o[u];
            if (d !== "children" && d !== "key") {
              K(e), T("Invalid prop `%s` supplied to `React.Fragment`. React.Fragment can only have `key` and `children` props.", d), K(null);
              break;
            }
          }
          e.ref !== null && (K(e), T("Invalid attribute `ref` supplied to `React.Fragment`."), K(null));
        }
      }
      function qe(e, o, u, d, R, b) {
        {
          var _ = ot(e);
          if (!_) {
            var v = "";
            (e === void 0 || typeof e == "object" && e !== null && Object.keys(e).length === 0) && (v += " You likely forgot to export your component from the file it's defined in, or you might have mixed up default and named imports.");
            var j = Rt(R);
            j ? v += j : v += Ue();
            var m;
            e === null ? m = "null" : Array.isArray(e) ? m = "array" : e !== void 0 && e.$$typeof === n ? (m = "<" + (I(e.type) || "Unknown") + " />", v = " Did you accidentally export a JSX literal instead of a component?") : m = typeof e, T("React.jsx: type is invalid -- expected a string (for built-in components) or a class/function (for composite components) but got: %s.%s", m, v);
          }
          var y = xt(e, o, u, R, b);
          if (y == null)
            return y;
          if (_) {
            var B = o.children;
            if (B !== void 0)
              if (d)
                if (Array.isArray(B)) {
                  for (var q = 0; q < B.length; q++)
                    Ke(B[q], e);
                  Object.freeze && Object.freeze(B);
                } else
                  T("React.jsx: Static children should always be an array. You are likely explicitly calling React.jsxs or React.jsxDEV. Use the Babel transform instead.");
              else
                Ke(B, e);
          }
          return e === a.Fragment ? wt(y) : Ct(y), y;
        }
      }
      function mt(e, o, u) {
        return qe(e, o, u, !0);
      }
      function yt(e, o, u) {
        return qe(e, o, u, !1);
      }
      var Ot = yt, Pt = mt;
      a.jsx = Ot, a.jsxs = Pt;
    }();
  }(xe)), xe;
}
(function(a) {
  process.env.NODE_ENV === "production" ? a.exports = qt() : a.exports = Gt();
})(ye);
const U = ye.exports.jsx, at = ye.exports.jsxs, Ht = At(({
  id: a,
  value: t
}, r) => {
  const {
    bus: n,
    props: {
      readOnly: i,
      spanStyle: s,
      spanClassName: l
    }
  } = ce(), c = ie(null);
  typeof r == "function" && r(c);
  const p = Kt(c);
  return /* @__PURE__ */ U("span", {
    ref: c,
    style: s,
    className: l,
    contentEditable: !i,
    suppressContentEditableWarning: !0,
    onInput: (f) => {
      var x;
      p();
      const C = (x = f.currentTarget.textContent) != null ? x : "";
      n.send(Y.Change, {
        key: a,
        value: C
      });
    },
    onPaste: zt,
    children: t
  });
});
function zt(a) {
  a.preventDefault();
  const t = a.clipboardData.getData("text");
  document.execCommand("insertText", !1, t);
}
const Jt = (a, t) => {
  const r = ie(null);
  return Re(() => {
    var n;
    if (r.current) {
      let i = (n = t.current.get(r.current)) == null ? void 0 : n.current;
      i.focus();
      let s = a.getPosition();
      s && i && z.setIndex(i, s), r.current = null;
    }
  }), r;
}, Xt = (a, t) => {
  const r = Ft(), n = {
    current: /* @__PURE__ */ new Map()
  }, {
    pieces: i,
    bus: s
  } = ce(), l = [...i.keys()], c = ie(null), p = Jt(r, n), g = (h) => {
    var M, T;
    const w = h.target, A = z.getCaretIndex(w), O = A === 0, k = A === ((M = w.textContent) == null ? void 0 : M.length), P = {
      [G.LEFT]: O ? E : null,
      [G.RIGHT]: k ? S : null,
      [G.UP]: null,
      [G.DOWN]: null,
      [G.DELETE]: k ? F : null,
      [G.BACKSPACE]: O ? N : null
    };
    (T = P[h.key]) == null || T.call(P);
    function E() {
      if (c.current && c.current !== 0) {
        let D = x()[c.current - 1].current;
        D == null || D.focus(), z.setCaretToEnd(D);
      }
      h.preventDefault();
    }
    function S() {
      var D;
      c.current !== null && c.current !== [...n.current.values()].length - 1 && ((D = x()[c.current + 1].current) == null || D.focus()), h.preventDefault();
    }
    function N() {
      if (c.current && c.current > 0) {
        p.current = f();
        let D = [...n.current.keys()][c.current], J = l.indexOf(D);
        s.send(Y.Delete, {
          key: l[J - 1]
        });
      }
    }
    function F() {
      if (c.current !== null && c.current !== [...n.current.values()].length - 1) {
        p.current = C();
        let D = [...n.current.keys()][c.current], J = l.indexOf(D);
        s.send(Y.Delete, {
          key: l[J + 1]
        });
      }
    }
  };
  function f() {
    var P, E, S, N;
    if (c.current === null)
      return null;
    let h = [...n.current.keys()][c.current - 1], w = [...n.current.keys()][c.current], A = (E = (P = n.current.get(h)) == null ? void 0 : P.current) == null ? void 0 : E.textContent, O = (N = (S = n.current.get(w)) == null ? void 0 : S.current) == null ? void 0 : N.textContent, k = A + O;
    return r.setPosition(A.length), oe(k);
  }
  function C() {
    var P, E, S, N;
    if (c.current === null)
      return null;
    let h = [...n.current.keys()][c.current + 1], w = [...n.current.keys()][c.current], A = (E = (P = n.current.get(h)) == null ? void 0 : P.current) == null ? void 0 : E.textContent, O = (N = (S = n.current.get(w)) == null ? void 0 : S.current) == null ? void 0 : N.textContent, k = O + A;
    return r.setPosition(O.length), oe(k);
  }
  function x() {
    return [...n.current.values()];
  }
  return {
    register: (h) => (w) => n.current.set(h, w),
    onFocus: (h) => {
      document.addEventListener("selectionchange", a), c.current = [...n.current.values()].findIndex((w) => w.current === h.target);
    },
    onBlur: () => {
      document == null || document.removeEventListener("selectionchange", a), setTimeout((h) => t(), 200), c.current = null;
    },
    onClick: () => {
      if (n.current.size === 1) {
        const h = [...n.current.values()][0].current;
        (h == null ? void 0 : h.textContent) === "" && h.focus();
      }
    },
    onKeyDown: g
  };
}, Zt = () => {
  const {
    pieces: a,
    options: t,
    props: {
      Mark: r,
      ...n
    },
    trigger: {
      check: i,
      clear: s
    }
  } = ce(), {
    register: l,
    ...c
  } = Xt(i, s), p = n.className ? Xe + " " + n.className : Xe;
  return /* @__PURE__ */ U("div", {
    className: p,
    style: n.style,
    ...c,
    children: [...a].map(([g, f]) => {
      var x, h, w;
      if (!ue(f))
        return /* @__PURE__ */ U(Ht, {
          ref: l(g),
          id: g,
          value: f
        }, g);
      const C = (w = (h = (x = t[f.childIndex]).initMark) == null ? void 0 : h.call(x, f)) != null ? w : f;
      return /* @__PURE__ */ U(r, {
        tabIndex: -1,
        ...C
      }, g);
    })
  });
};
const Qt = ({
  data: a,
  word: t,
  style: r,
  onSelect: n,
  ...i
}) => {
  const [s, l] = Ce(NaN), c = ee(() => a.filter((p) => p.toLowerCase().indexOf(t.toLowerCase()) > -1), [t]);
  return c.length ? /* @__PURE__ */ U("ul", {
    className: "mk-suggestions",
    style: r,
    children: c.map((p, g) => {
      let f;
      return g === s && (f = "mk-suggestion-active"), /* @__PURE__ */ U("li", {
        className: f,
        onClick: (C) => n({
          label: p,
          value: g.toString()
        }),
        children: p
      }, p);
    })
  }) : null;
}, er = () => {
  var x, h;
  const {
    pieces: a,
    bus: t,
    trigger: {
      word: r,
      option: n,
      style: i,
      text: s,
      indexBefore: l,
      triggeredValue: c
    },
    props: {
      Overlay: p = Qt
    }
  } = ce();
  if (r === void 0)
    return null;
  const f = {
    word: r,
    style: i,
    onSelect: ({
      label: w,
      value: A
    }) => {
      const O = me(n.markup, w, A);
      let k;
      for (let [E, S] of a.entries())
        if (S === s) {
          k = E;
          break;
        }
      let P = (s == null ? void 0 : s.slice(0, l)) + O + (s == null ? void 0 : s.slice(l + c.length));
      k && t.send(Y.Change, {
        value: P,
        key: k
      });
    },
    data: n.data
  }, C = (h = (x = n.initOverlay) == null ? void 0 : x.call(n, f)) != null ? h : f;
  return Dt(p, C);
}, tr = (a) => ee(() => $t(a), [a]), rr = (a, t) => {
  const r = ee(se.split(a, t), [a]);
  return ee(n, [r.length]);
  function n() {
    return r.reduce((s, l) => s.set(i(l, s), l), /* @__PURE__ */ new Map());
    function i(s, l) {
      let c = ue(s) ? s.label + s.value : s, p = 0, g = oe(c, p);
      for (; l.has(g); )
        g = oe(c, p++);
      return g;
    }
  }
}, nr = (a) => {
  const [t, r] = Ce(), n = Je(() => r(void 0), []), i = Je(() => {
    var s;
    for (let l of a) {
      let {
        word: c,
        triggeredValue: p,
        text: g,
        indexBefore: f
      } = (s = ar(l.trigger)) != null ? s : {};
      if (c !== void 0) {
        r({
          word: c,
          triggeredValue: p,
          style: ir(),
          option: l,
          text: g,
          indexBefore: f
        });
        return;
      }
    }
    r(void 0);
  }, []);
  return we({}, t, {
    check: i,
    clear: n
  });
};
function ar(a) {
  var E, S, N, F;
  if (!a)
    return;
  const t = window.getSelection(), r = t == null ? void 0 : t.anchorOffset, n = (E = t == null ? void 0 : t.anchorNode) == null ? void 0 : E.textContent;
  if (!r || !n)
    return;
  const i = n.slice(0, r), s = n.slice(r), l = Q(a), c = "\\s?" + l + "\\w*$", p = new RegExp(c), g = new RegExp(/^\w*/), f = i.match(p);
  if (!f)
    return;
  const C = (S = f[0]) != null ? S : "", x = f.index + (or(C) ? 1 : 0), h = (F = (N = s.match(g)) == null ? void 0 : N[0]) != null ? F : "", w = C + h, O = Lt(a).exec(w), k = O == null ? void 0 : O[0], P = O == null ? void 0 : O[1];
  if (P !== void 0)
    return {
      word: P,
      triggeredValue: k,
      text: n,
      indexBefore: x
    };
}
function or(a) {
  return a.startsWith(" ");
}
function ir() {
  var t;
  const a = (t = window.getSelection()) == null ? void 0 : t.getRangeAt(0).getBoundingClientRect();
  return a ? {
    left: a.left,
    top: a.top + 20
  } : {
    left: 0,
    top: 0
  };
}
var L;
class sr {
  constructor() {
    He(this, L, {});
  }
  get length() {
    return Object.keys($(this, L)).length;
  }
  get events() {
    return Object.keys($(this, L)).filter(Vt).reduce((t, r) => (t[r] = (n) => this.send(r, n), t), {});
  }
  send(t, r) {
    const n = $(this, L)[t];
    !n || n.forEach((i) => i(r));
  }
  listen(t, r) {
    var i, s;
    const n = r;
    return (s = (i = $(this, L))[t]) != null || (i[t] = []), $(this, L)[t].push(n), () => {
      $(this, L)[t] = $(this, L)[t].filter((l) => l !== n);
    };
  }
}
L = new WeakMap();
function ur(a) {
  const {
    bus: t,
    pieces: r,
    options: n,
    props: i
  } = a;
  Re(() => t.listen(Y.Change, (s) => {
    const {
      key: l,
      value: c = ""
    } = s;
    r.set(l, c), i.onChange(Qe([...r.values()], n));
  }), [r]), Re(() => t.listen(Y.Delete, (s) => {
    const {
      key: l
    } = s;
    r.delete(l), i.onChange(Qe([...r.values()], n));
  }), [r]);
}
const cr = ({
  props: a,
  children: t
}) => {
  const r = tr(a.children), n = rr(a.value, r), i = nr(r), s = Ce(() => new sr())[0], l = {
    options: r,
    props: a,
    pieces: n,
    trigger: i,
    bus: s
  };
  return ur(l), /* @__PURE__ */ at(Yt, {
    value: l,
    children: [" ", t, " "]
  });
}, lr = (a) => /* @__PURE__ */ at(cr, {
  props: a,
  children: [/* @__PURE__ */ U(Zt, {}), /* @__PURE__ */ U(er, {})]
}), gr = ({
  trigger: a = "@",
  markup: t = "@[__label__](__value__)",
  data: r = [],
  ...n
}) => null;
function vr(a, t, r) {
  const n = Bt(t) ? {
    Mark: a,
    Overlay: t,
    children: r
  } : {
    Mark: a,
    children: t
  };
  return (i) => {
    const s = we({}, i, n);
    return lr(s);
  };
}
export {
  lr as MarkedInput,
  gr as Option,
  me as annotate,
  vr as createMarkedInput,
  pr as denote
};
//# sourceMappingURL=rc-marked-input.js.map
